From f8ec88c36fe903f2687f194a0a3589e67679d705 Mon Sep 17 00:00:00 2001
From: Kalle Valo <kvalo@codeaurora.org>
Date: Fri, 23 Sep 2016 11:11:47 +0300
Subject: [PATCH 4/7] stubs: git: fake conflict with am command

Needed to test that pwcli correctly collegs logs from failures.

Signed-off-by: Kalle Valo <kvalo@codeaurora.org>
---

Copyright (c) 2016, The Linux Foundation.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 stubs/cmdtests/git.script |    5 +++++
 stubs/cmdtests/git.stdout |   12 ++++++++++++
 stubs/git                 |   24 +++++++++++++++++++++++-
 stubs/stubs.py            |    6 ++++++
 4 files changed, 46 insertions(+), 1 deletion(-)

diff --git a/stubs/cmdtests/git.script b/stubs/cmdtests/git.script
index 1947a8f46fec..678250e35401 100755
--- a/stubs/cmdtests/git.script
+++ b/stubs/cmdtests/git.script
@@ -135,6 +135,11 @@ def main():
                        'sed -e "/foo/d"', 'HEAD^..HEAD'])
       print
 
+      print 'test git am conflict'
+      gitstub.enable_conflict()
+      git_am(stub_git, buf)
+      print
+
       # cleanup
       gitstub.cleanup()
 
diff --git a/stubs/cmdtests/git.stdout b/stubs/cmdtests/git.stdout
index aa31c5acda05..11e9de012539 100644
--- a/stubs/cmdtests/git.stdout
+++ b/stubs/cmdtests/git.stdout
@@ -23,3 +23,15 @@ fb409caeb2ec foo: test 1
 
 test git filter-branch
 
+test git am conflict
+Applying: foo: conflict patch
+Using index info to reconstruct a base tree...
+Falling back to patching base and 3-way merge...
+Auto-merging foo/bar.c
+CONFLICT (content): Merge conflict in drivers/net/wireless/ath/foo/core.h
+Failed to merge in the changes.
+Patch failed at 0001 foo: conflict patch
+When you have resolved this problem run "git am --resolved".
+If you would prefer to skip this patch, instead run "git am --skip".
+To restore the original branch and stop patching run "git am --abort".
+
diff --git a/stubs/git b/stubs/git
index 6964c73bf6d2..0a11423ece53 100755
--- a/stubs/git
+++ b/stubs/git
@@ -55,11 +55,33 @@ def cmd_branch(args):
       print f.read()
       f.close()
 
+def cmd_am_conflict(args):
+      conflict_msg = '''Applying: foo: conflict patch
+Using index info to reconstruct a base tree...
+Falling back to patching base and 3-way merge...
+Auto-merging foo/bar.c
+CONFLICT (content): Merge conflict in drivers/net/wireless/ath/foo/core.h
+Failed to merge in the changes.
+Patch failed at 0001 foo: conflict patch
+When you have resolved this problem run "git am --resolved".
+If you would prefer to skip this patch, instead run "git am --skip".
+To restore the original branch and stop patching run "git am --abort".'''
+
+      # git 1.7.9.5 prints the whole message to stdout and nothing to stderr
+      sys.stdout.write(conflict_msg)
+
+      sys.exit(1)
+
 def cmd_am(args):
       if not args.s:
-            # -s switch now used, exit
+            # -s switch not used, exit
             sys.exit(0)
 
+      conflict_file = os.path.join(gitdir, 'conflict')
+      if os.path.exists(conflict_file):
+            cmd_am_conflict(args)
+            os.remove(conflict_file)
+      
       objectsdir = os.path.join(gitdir, 'objects')
       commitsfile = os.path.join(objectsdir, 'commits')
 
diff --git a/stubs/stubs.py b/stubs/stubs.py
index 65fc9c2fafc3..1d853b2f13ad 100644
--- a/stubs/stubs.py
+++ b/stubs/stubs.py
@@ -217,6 +217,7 @@ class StgStub():
 class GitStub():
     def __init__(self, smtpport=SMTP_PORT):
         self.gitdir = os.path.join(testdatadir, 'git')
+        self.conflict_file = os.path.join(self.gitdir, 'conflict')
 
         logger.debug('GitStub(): gitdir=%r' % (self.gitdir))
 
@@ -271,6 +272,11 @@ class GitStub():
     def cleanup(self):
         shutil.rmtree(self.gitdir)
 
+    def enable_conflict(self):
+        f = open(self.conflict_file, 'w')
+        f.write('enable\n')
+        f.close()
+
 class SmtpdStub():
 
     def __init__(self, port=SMTP_PORT):
-- 
1.7.9.5

